PROGRAM WN_IN
  IMPLICIT NONE
  REAL*8::xe,ye,x00,y00,x0,y0,xn,yn,xn0,yn0,yf
  REAL*8:: la,lb,lc,w,sum,nwn,theta,K2,phi
  INTEGER::NMAX,NFINAL,i,n,j,m,mm
  REAL*8, PARAMETER:: pi=4.0*ATAN(1.0), K1=0.1, THS=1E-5
  INTEGER,PARAMETER:: period=1, m1=3, m2=5
  !---------------------------------------------------------------
  !---------------------------------------------------------------
  ! Parameters
  NMAX=5E3
  NFINAL=10E4
  K2=0.2
  !
  DO j=1,3
     IF(j.EQ.1) THEN
        phi=0.0
        xe=0.0; ye=0.0 ! Elliptic point
        yf=0.04281
        OPEN(1, FILE='WindingNumberProfile_phi_0.dat', STATUS='UNKNOWN')
     ELSE IF(j.EQ.2) THEN
        phi=pi
        xe=0.0; ye=0.0
        yf=0.03273
        OPEN(1, FILE='WindingNumberProfile_phi_pi.dat', STATUS='UNKNOWN')
     ELSE IF(j.EQ.3) THEN
        phi=pi/2.0
        xe=-0.0336; ye=0.0
        yf=0.040934
        OPEN(1, FILE='WindingNumberProfile_phi_pi-2.dat', STATUS='UNKNOWN')
     END IF
  !
     IC: DO i=1,NMAX !Initial conditions
        y00=yf*i/(1.0*NMAX)
        x00=xe
        !
        x0=x00;y0=y00
        nwn=0.0; sum=0.0; w=0.0
        xn0=x0;yn0=y0
        TIME: DO n=1,NFINAL !Time evolution
           yn=MOD(y0-K1/(2.0*m1*pi)*SIN(2.0*pi*m1*x0)-K2/(2.0*m2*pi)*SIN(2.0*m2*pi*x0+phi),1.0)
           IF(yn.LT.-0.50) yn=yn+1.0
           IF(yn.GT.0.50) yn=yn-1.0
           !
           xn=MOD(x0+yn,1.0)
           IF(xn.LT.-0.50) xn=xn+1.0
           IF(xn.GT.0.50) xn=xn-1.0
           !
           IF(MOD(n,period).EQ.0) THEN           
              la=SQRT((xn0-xe)**2.0+(yn0-ye)**2.0)
              lb=SQRT((xn-xe)**2.0+(yn-ye)**2.0)
              lc=SQRT((xn-xn0)**2.0+(yn-yn0)**2.0)
              theta=ACOS((la**2.0+lb**2.0-lc**2.0)/(2.0*la*lb))!/(2.0*pi)
              !
              w=w+theta
              IF(n.GE.NFINAL/2) THEN
                 nwn=nwn+1.0
                 sum=sum+w/(1.0*n)
              END IF
              xn0=xn;yn0=yn
           END IF
           x0=xn;y0=yn
        END DO TIME
        IF(ABS(w/(1.0*NFINAL)-sum/nwn).LT.THS) WRITE(1,*) y00,w/(1.0*pi*NFINAL),J
     END DO IC
     CLOSE(1)
  END DO
END PROGRAM WN_IN
