PROGRAM MAIN
  IMPLICIT NONE
  REAL*8::K1,K2,x00,y00,x0,y0,xn,yn,d,delta,phi
  INTEGER::i,n,n1,n2,n3,NE,j,k,nep,jj,IDFP,m1,m2
  REAL*8, PARAMETER:: pi=4.0*ATAN(1.0), THS=1E-5
  INTEGER, PARAMETER:: nfinal=100, nmax=5E5, ntotal=200
  REAL*8, DIMENSION(nmax):: X0e
  !------------------------------------------------------------------
  m1=4;m2=5;phi=0.0
  OPEN(1,FILE='m1_4_m2_5_phi_0.dat', STATUS='UNKNOWN')
  !-----------------------------------------------------------------
  PARAMETER1: DO j=1,ntotal
     PARAMETER2: DO jj=1,ntotal
        K1=4.0*j/(1.0*ntotal) 
        K2=4.0*jj/(1.0*ntotal)     
        n1=0;X0e=0.0; nep=0   
        IC: DO i=0,nmax !Initial conditions
           y00=0.0
           x00=-0.5+i/(1.0*nmax)+0.1*THS
           IDFP=0
           CALL FP(K1,K2,m1,m2,x00,IDFP) !Identify fixed point
           IF(IDFP.EQ.1) THEN
              x0=x00;y0=y00
              DO n=0,nfinal
                 yn=MOD(y0-K1/(2.0*m1*pi)*SIN(2.0*pi*m1*x0)-K2/(2.0*m2*pi)*SIN(2.0*m2*pi*x0+phi),1.0)
                 IF(yn.LT.-0.50) yn=yn+1.0
                 IF(yn.GT.0.50) yn=yn-1.0
                 !
                 xn=MOD(x0+yn,1.0)
                 IF(xn.LT.-0.50) xn=xn+1.0
                 IF(xn.GT.0.50) xn=xn-1.0
                 !
                 x0=xn; y0=yn
                 !
                 d=ABS(ABS(xn)-ABS(x00))
                 !
                 IF(d.GT.THS.OR.ABS(yn).GT.THS) EXIT
              END DO
              IF(d.LE.THS.AND.ABS(yn).LE.THS) THEN
                 n1=n1+1
                 x0e(n1)=x00
              END IF
           END IF
        END DO IC
        !
        IF(n1.EQ.1) THEN
           WRITE(1,*) K1,K2,1
        ELSE IF(n1.GT.1) THEN
           nep=1
           DO k=2,n1
              IF(ABS(X0e(k)-X0e(k-1)).GT.1E-4) THEN
                 nep=nep+1
              END IF
           END DO
           IF(ABS(X0e(1)+0.5).LT.1E-6.AND.ABS(X0e(n1)-0.5).LT.1E-6) nep=nep-1
           WRITE(1,*) K1,K2,nep
        ELSE IF(n1.EQ.0) THEN
           WRITE(1,*) K1,K2,0
        END IF
     END DO PARAMETER2
  END DO PARAMETER1
  !
CONTAINS
  !
  SUBROUTINE FP(k1,k2,m1,m2,x,IDFP)
    IMPLICIT NONE
    REAL*8::k1,k2,x,x0,y0,xn,yn
    INTEGER:: m1,m2,IDFP
    !
    x0=x; y0=0.0
    !
    yn=MOD(y0-K1/(2.0*m1*pi)*SIN(2.0*pi*m1*x0)-K2/(2.0*m2*pi)*SIN(2.0*m2*pi*x0+pi),1.0)
    IF(yn.LT.-0.50) yn=yn+1.0
    IF(yn.GT.0.50) yn=yn-1.0
    !
    xn=MOD(x0+yn,1.0)
    IF(xn.LT.-0.50) xn=xn+1.0
    IF(xn.GT.0.50) xn=xn-1.0
    !
    IF(ABS(ABS(xn)-ABS(x0)).LT.THS) IDFP=1
  END SUBROUTINE FP
END PROGRAM MAIN
