PROGRAM MAIN
  IMPLICIT NONE
  REAL*8::K1,K2,x00,y00,x0,y0,xn,yn,d,delta,phi
  INTEGER::i,n,n1,n2,n3,NE,j,k,nep,jj,IDFP
  REAL*8, PARAMETER:: pi=4.0*ATAN(1.0), THS=1E-6
  INTEGER, PARAMETER:: nfinal=500, nmax=1E6, ntotal=1000
  INTEGER, PARAMETER:: m1=1, m2=5
  REAL*8, DIMENSION(nmax):: X0e
  !------------------------------------------------------------------
  !-----------------------------------------------------------------
  K1=0.05
  DO j=1,3
     IF(j.EQ.1) THEN
        phi=0.0
        OPEN(1,FILE='EllipticPoints_phi_0.dat', STATUS='UNKNOWN')
        OPEN(2,FILE='HyperbolicPoints_phi_0.dat', STATUS='UNKNOWN')
     ELSE IF(j.EQ.2) THEN
        phi=pi
        OPEN(1,FILE='EllipticPoints_phi_pi.dat', STATUS='UNKNOWN')
        OPEN(2,FILE='HyperbolicPoints_phi_pi.dat', STATUS='UNKNOWN')
     ELSE IF(j.EQ.3) THEN
        phi=pi/2.0
        OPEN(1,FILE='EllipticPoints_phi_pi-2.dat', STATUS='UNKNOWN')
        OPEN(2,FILE='HyperbolicPoints_phi_pi-2.dat', STATUS='UNKNOWN')
     END IF
     PARAMETER_K2: DO jj=1,ntotal
        K2=0.50*jj/(1.0*ntotal)     
        n1=0;X0e=0.0; nep=0   
        IC: DO i=1,nmax !Initial conditions
           y00=0.0
           x00=-0.5+i/(1.0*nmax)+0.1*THS
           IDFP=0
           CALL FP(K1,K2,m1,m2,x00,phi,IDFP)
           IF(IDFP.EQ.1) THEN
              x0=x00+0.1*THS;y0=y00
              DO n=0,nfinal
                 yn=MOD(y0-K1/(2.0*m1*pi)*SIN(2.0*pi*m1*x0)-K2/(2.0*m2*pi)*SIN(2.0*m2*pi*x0+phi),1.0)
                 IF(yn.LT.-0.50) yn=yn+1.0
                 IF(yn.GT.0.50) yn=yn-1.0
                 !
                 xn=MOD(x0+yn,1.0)
                 IF(xn.LT.-0.50) xn=xn+1.0
                 IF(xn.GT.0.50) xn=xn-1.0
                 !
                 x0=xn; y0=yn
                 !
                 d=ABS(ABS(xn)-ABS(x00))
                 !
                 IF(d.GT.THS.OR.ABS(yn).GT.THS) THEN
                    WRITE(2,*) K2, x00
                    EXIT
                 END IF
              END DO
              IF(d.LE.THS.AND.ABS(yn).LE.THS) THEN
                 n1=n1+1
                 x0e(n1)=x00
                 WRITE(1,*) K2, x00
              END IF
           END IF
        END DO IC
     END DO PARAMETER_K2
     CLOSE(2)
  END DO
  !
CONTAINS
  !
  SUBROUTINE FP(k1,k2,m1,m2,x,phi,IDFP)
    IMPLICIT NONE
    REAL*8::k1,k2,x,x0,y0,xn,yn,phi
    INTEGER:: m1,m2,IDFP
    !
    x0=x; y0=0.0
    !
    yn=MOD(y0-K1/(2.0*m1*pi)*SIN(2.0*pi*m1*x0)-K2/(2.0*m2*pi)*SIN(2.0*m2*pi*x0+phi),1.0)
    IF(yn.LT.-0.50) yn=yn+1.0
    IF(yn.GT.0.50) yn=yn-1.0
    !
    xn=MOD(x0+yn,1.0)
    IF(xn.LT.-0.50) xn=xn+1.0
    IF(xn.GT.0.50) xn=xn-1.0
    !
    IF(ABS(ABS(xn)-ABS(x0)).LT.THS.AND.ABS(yn).LT.THS) IDFP=1
  END SUBROUTINE FP
END PROGRAM MAIN
